#Python Version 1.0 of Nim
#player goes first and chooses pile size
#computer choices are random from 1,2 or 3 coins and are represented by asterisks

#this basic version establishes a structure for later versions
#it uses no AI at this stage
#time delay factor introduced to enhance gameplay

import time, random

#function to print coins
def print_asterisk(n):
    for count in range(n):
        print("*", end=' ')
    print()

#asks for player move and checks validity
def check_move(checkval):
    while True:
        n=int(input("Your turn: "))
        if n not in choices:
            print("1, 2 or 3 only")
        elif n>checkval:
            print("Cannot take more than are there!")
        else:       
            return n
        
#generates computer move and checks validity
def comp_move(checkval):
    n=random.choice(choices)   # the 'choice' method in the built-in random method is one approach for randomly selecting one item from a list
    while n>checkval:
         n=random.choice(choices)
    return n

#game starts here        
pile=int(input("How many coins in the pile to start with? "))
win=False
choices=[1,2,3]
print_asterisk(pile)
move=check_move(pile)
pile=pile-move
print_asterisk(pile)

#loop for main game
while pile>0:
#comp move
    print("...thinking...") # introducing a delay makes game more exciting for humans!
    time.sleep(2)
    move=comp_move(pile)
    print("Computer says it will take ",move)

    print_asterisk(pile-move)
    pile=pile-move
    if pile<=0:
        win=True
        break

#player move
    move=check_move(pile)
    print_asterisk(pile-move)
    pile=pile-move
    if pile<=0:
        win=False
        break

#game ends
if win==False:    
    print("You lose!")
else:
    print("Computer loses!")
