#Python Version 2.0 of Nim
#Computer goes first
#Player chooses pile size N
#In this approach, the computer uses the modular arithmetic expression (N - 1) mod 4 to arrive at moves matching those deduced in Table 11.7 of the text.

#Coins are represented by asterisks and a count is included

#Computer may make illegal last move before admitting to losing! Can you correct this part of its AI? 

#Time delay factor introduced to enhance gameplay

import time, random

#function to print coins
def print_asterisk(n):
    print(n,"coins left.")
    for count in range(n):
        print("*", end=' ')
    print()

#checks player move vaildity
def check_move(checkval):
    while True:
        n=int(input("You take: "))
        if n not in choices:
            print("1, 2 or 3 only")
        elif n>checkval:
            print("Cannot take more than are there!")
        else:       
            return n
        
#set size of pile
pile=int(input("How many coins in the pile to start with? "))
win=False
choices=[1,2,3]
print_asterisk(pile)
move=0
#loop for main game
while pile>0:
#comp move
    print("...thinking...")
    time.sleep(2)
    #If start pile is already a losing pile for the computer (1,5,9,13...)
    #which can be tested since (pile-1) mod 4 equals 0 in these cases,then the computer will simply randomly choose 1, 2 or 3
    #as it cannot make a winning move

    #If on the other hand the pile is not one of these losing values
    #the computer needs to force player to one of these totals.
    #In other words, the computer move should be the remainder found by calculating (pile-1) mod 4 
 
    
    if (pile)%4 != 1:
        move = (pile-1)%4
        print("Computer says it will take ",move)
        print_asterisk(pile-move)
        pile=pile-move
        if pile<=0:
            win=True
            break
    else:
        print("I'm not happy with the number in this pile!..here goes anyhow....")
        move=random.choice(choices)
        print("Computer says it will take ",move)
        print_asterisk(pile-move)
        pile=pile-move
        if pile<=0:
            win=True
            break
#player move
    if pile > 0:
        move=check_move(pile)
        print_asterisk(pile-move)
        pile=pile-move
        if pile<=0:
            win=False
            break

#game ends
if win==False:    
    print("You lose!")
else:
    print("Computer loses!")
